package it.sauronsoftware.cron4j;

import java.util.ArrayList;
import java.util.Iterator;

/**
 * A ValueMatcher coumpounded by others ValueMatchers. It validates a value
 * checking its validity againts its inner-matchers. If at least one
 * inner-matcher finds valid the value, then the whole matcher will account it
 * as valid.
 * 
 * @author Carlo Pelliccia
 */
class ValueMatcherSet implements ValueMatcher {

	/**
	 * The inner-matchers.
	 */
	private ArrayList matchers = new ArrayList();

	/**
	 * Add a ValueMatcher to the set.
	 * 
	 * @param valueMatcher
	 *            The ValueMatcher.
	 */
	public void addValueMatcher(ValueMatcher valueMatcher) {
		matchers.add(valueMatcher);
	}

	/**
	 * Returns true if at least one inner-matcher does it.
	 */
	public boolean match(int value) {
		for (Iterator i = matchers.iterator(); i.hasNext();) {
			ValueMatcher valueMatcher = (ValueMatcher) i.next();
			if (valueMatcher.match(value)) {
				return true;
			}
		}
		return false;
	}

}
